--- asterisk-1.4.19-orig/apps/app_queue.c	2008-03-18 17:52:15.000000000 -0300
+++ asterisk-1.4.19/apps/app_queue.c	2008-05-14 10:53:26.000000000 -0300
@@ -2783,6 +2783,17 @@
 			ast_channel_setoption(qe->chan, AST_OPTION_TONE_VERIFY, &nondataquality, sizeof(nondataquality), 0);
 		if (!strcmp(peer->tech->type, "Zap"))
 			ast_channel_setoption(peer, AST_OPTION_TONE_VERIFY, &nondataquality, sizeof(nondataquality), 0);
+
+		/* Create Channel var AGENTID. Enable using "^{AGENTID}" on MONITOR_FILENAME */
+		strcpy(vars, peer->name);
+		/* Subst '/' to '-' on channel name (so it can be used on a filename) */
+		for (p = vars; *p ; p++) {
+			if (*p == '/') {
+				*p = '-';
+			}
+		}
+		pbx_builtin_setvar_helper(qe->chan, "AGENTID", vars);
+
 		/* Update parameters for the queue */
 		time(&now);
 		recalc_holdtime(qe, (now - qe->start));
